/******************************************************************************************
 *	Chili DirectX Framework Version 16.07.20											  *
 *	Game.cpp																			  *
 *	Copyright 2016 PlanetChili.net <http://www.planetchili.net>							  *
 *																						  *
 *	This file is part of The Chili DirectX Framework.									  *
 *																						  *
 *	The Chili DirectX Framework is free software: you can redistribute it and/or modify	  *
 *	it under the terms of the GNU General Public License as published by				  *
 *	the Free Software Foundation, either version 3 of the License, or					  *
 *	(at your option) any later version.													  *
 *																						  *
 *	The Chili DirectX Framework is distributed in the hope that it will be useful,		  *
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of						  *
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the						  *
 *	GNU General Public License for more details.										  *
 *																						  *
 *	You should have received a copy of the GNU General Public License					  *
 *	along with The Chili DirectX Framework.  If not, see <http://www.gnu.org/licenses/>.  *
 ******************************************************************************************/
#include "MainWindow.h"
#include "Game.h"

Game::Game( MainWindow& wnd )
	:
	wnd( wnd ),
	gfx( wnd )
{
}

void Game::Go()
{
	gfx.BeginFrame();
	UpdateModel();
	ComposeFrame();
	gfx.EndFrame();
}

void Game::UpdateModel()
{
	int moveX = 0;
	int moveY = 0;

	if (wnd.kbd.KeyIsPressed( VK_LEFT ))
		moveX -= 1;
	if (wnd.kbd.KeyIsPressed( VK_RIGHT ))
		moveX += 1;
	if (wnd.kbd.KeyIsPressed( VK_UP ))
		moveY -= 1;
	if (wnd.kbd.KeyIsPressed( VK_DOWN ))
		moveY += 1;

	int growX = 0;
	int growY = 0;

	if (wnd.kbd.KeyIsPressed( 'A' ))
		growX -= 1;
	if (wnd.kbd.KeyIsPressed( 'D' ))
		growX += 1;
	if (wnd.kbd.KeyIsPressed( 'W' ))
		growY -= 1;
	if (wnd.kbd.KeyIsPressed( 'S' ))
		growY += 1;

	r.Update( moveX, moveY, growX, growY );
}

void Game::ComposeFrame()
{
	r.Draw( gfx );
}
